# Database Report

## **Number of Patients:** 100
## **Number of Studies:** 315
## **Number of Series:** 3123


## Modality Summary
| Modality   |   Count |
|:-----------|--------:|
| MR         |     152 |
| SEG        |      68 |
| CT         |     138 |
| OT         |       1 |
| PT         |      10 |
| RTSTRUCT   |      16 |
| RTDOSE     |      16 |
| RTPLAN     |      13 |
| DX         |       8 |
| SR         |      10 |
| MG         |       5 |
| NM         |       1 |
| CR         |      11 |

## Data Summary
| Patient ID   |   Number of Studies |   Number of Series | Unique Modalities                            |
|:-------------|--------------------:|-------------------:|:---------------------------------------------|
| TCGA-06-0184 |                  12 |                183 | {'SEG', 'MR'}                                |
| TCGA-06-0185 |                  16 |                176 | {'SEG', 'MR'}                                |
| TCGA-BB-A5HY |                  11 |                121 | {'CT', 'OT', 'MR'}                           |
| TCGA-06-0188 |                   9 |                110 | {'SEG', 'MR'}                                |
| TCGA-CV-7090 |                  15 |                 93 | {'PT', 'CT', 'MR'}                           |
| TCGA-06-0138 |                   6 |                 90 | {'SEG', 'MR'}                                |
| TCGA-06-1084 |                   6 |                 77 | {'SEG', 'MR'}                                |
| TCGA-06-0139 |                   5 |                 76 | {'SEG', 'MR'}                                |
| TCGA-CV-7243 |                  15 |                 72 | {'RTDOSE', 'CT', 'RTSTRUCT'}                 |
| TCGA-CV-A6K0 |                  13 |                 71 | {'CT', 'RTDOSE', 'RTSTRUCT'}                 |
| TCGA-CV-A6JY |                  14 |                 68 | {'RTPLAN', 'CT', 'RTDOSE', 'RTSTRUCT'}       |
| TCGA-DD-A4NG |                   8 |                 58 | {'PT', 'CT', 'MR'}                           |
| TCGA-06-0238 |                   3 |                 54 | {'SEG', 'MR'}                                |
| TCGA-06-1802 |                   3 |                 51 | {'SEG', 'MR'}                                |
| TCGA-D1-A16D |                   9 |                 43 | {'PT', 'CT', 'MR'}                           |
| TCGA-06-0164 |                   3 |                 36 | {'SEG', 'MR'}                                |
| TCGA-06-0137 |                   2 |                 34 | {'SEG', 'MR'}                                |
| TCGA-14-1794 |                   4 |                 34 | {'CT', 'SEG', 'MR'}                          |
| TCGA-06-0130 |                   2 |                 33 | {'SEG', 'MR'}                                |
| TCGA-CS-6186 |                   2 |                 33 | {'CT', 'SEG', 'MR'}                          |
| TCGA-CV-A6JO |                   8 |                 32 | {'RTPLAN', 'CT', 'RTDOSE', 'PT', 'RTSTRUCT'} |
| TCGA-06-0154 |                   1 |                 32 | {'SEG', 'MR'}                                |
| TCGA-02-0075 |                   1 |                 31 | {'SEG', 'MR'}                                |
| TCGA-06-0190 |                   2 |                 31 | {'SEG', 'MR'}                                |
| TCGA-02-0087 |                   1 |                 30 | {'SEG', 'MR'}                                |
| TCGA-CV-A6K1 |                   7 |                 28 | {'RTDOSE', 'CT', 'RTSTRUCT', 'RTPLAN'}       |
| TCGA-G2-A3IE |                   6 |                 28 | {'CT', 'DX', 'MR'}                           |
| TCGA-AO-A0JB |                   3 |                 26 | {'SR', 'MG', 'MR'}                           |
| TCGA-02-0064 |                   1 |                 25 | {'SEG', 'MR'}                                |
| TCGA-02-0059 |                   1 |                 25 | {'SEG', 'MR'}                                |
| TCGA-02-0034 |                   1 |                 25 | {'SEG', 'MR'}                                |
| TCGA-06-0122 |                   1 |                 25 | {'SEG', 'MR'}                                |
| TCGA-06-0644 |                   1 |                 25 | {'SEG', 'MR'}                                |
| TCGA-06-0646 |                   1 |                 25 | {'SEG', 'MR'}                                |
| TCGA-06-5413 |                   1 |                 25 | {'SEG', 'MR'}                                |
| TCGA-06-0192 |                   2 |                 25 | {'SEG', 'MR'}                                |
| TCGA-06-0179 |                   1 |                 25 | {'SEG', 'MR'}                                |
| TCGA-08-0359 |                   1 |                 25 | {'SEG', 'MR'}                                |
| TCGA-06-5417 |                   1 |                 25 | {'SEG', 'MR'}                                |
| TCGA-02-0069 |                   1 |                 24 | {'SEG', 'MR'}                                |
| TCGA-06-0119 |                   1 |                 24 | {'SEG', 'MR'}                                |
| TCGA-CV-A6K2 |                   5 |                 24 | {'RTPLAN', 'CT', 'RTSTRUCT', 'RTDOSE'}       |
| TCGA-08-0389 |                   1 |                 24 | {'SEG', 'MR'}                                |
| TCGA-06-0149 |                   1 |                 24 | {'SEG', 'MR'}                                |
| TCGA-CR-7368 |                   4 |                 24 | {'PT', 'CT', 'MR'}                           |
| TCGA-06-0158 |                   2 |                 24 | {'SEG', 'MR'}                                |
| TCGA-02-0086 |                   1 |                 24 | {'SEG', 'MR'}                                |
| TCGA-08-0355 |                   1 |                 24 | {'SEG', 'MR'}                                |
| TCGA-06-2570 |                   1 |                 23 | {'SEG', 'MR'}                                |
| TCGA-02-0027 |                   1 |                 22 | {'SEG', 'MR'}                                |
| TCGA-B9-A44B |                   2 |                 22 | {'PT', 'CT', 'MR'}                           |
| TCGA-06-6389 |                   1 |                 22 | {'SEG', 'MR'}                                |
| TCGA-50-5072 |                   4 |                 22 | {'PT', 'CT', 'NM'}                           |
| TCGA-08-0385 |                   2 |                 22 | {'SEG', 'MR'}                                |
| TCGA-06-0142 |                   1 |                 22 | {'SEG', 'MR'}                                |
| TCGA-02-0068 |                   1 |                 22 | {'SEG', 'MR'}                                |
| TCGA-06-0240 |                   1 |                 22 | {'SEG', 'MR'}                                |
| TCGA-08-0360 |                   1 |                 21 | {'SEG', 'MR'}                                |
| TCGA-06-0182 |                   1 |                 21 | {'SEG', 'MR'}                                |
| TCGA-G2-A2EK |                  11 |                 21 | {'CR', 'CT', 'DX'}                           |
| TCGA-06-0187 |                   1 |                 21 | {'SEG', 'MR'}                                |
| TCGA-08-0392 |                   1 |                 21 | {'SEG', 'MR'}                                |
| TCGA-06-5408 |                   1 |                 21 | {'SEG', 'MR'}                                |
| TCGA-08-0390 |                   1 |                 20 | {'SEG', 'MR'}                                |
| TCGA-02-0070 |                   1 |                 20 | {'SEG', 'MR'}                                |
| TCGA-02-0054 |                   1 |                 19 | {'SEG', 'MR'}                                |
| TCGA-08-0356 |                   1 |                 19 | {'SEG', 'MR'}                                |
| TCGA-G2-A2EL |                   5 |                 19 | {'CR', 'CT', 'DX'}                           |
| TCGA-AO-A0JF |                   5 |                 19 | {'SR', 'MG', 'MR'}                           |
| TCGA-06-0177 |                   1 |                 19 | {'SEG', 'MR'}                                |
| TCGA-02-0011 |                   1 |                 18 | {'SEG', 'MR'}                                |
| TCGA-02-0033 |                   1 |                 18 | {'SEG', 'MR'}                                |
| TCGA-02-0047 |                   1 |                 18 | {'SEG', 'MR'}                                |
| TCGA-02-0037 |                   1 |                 18 | {'SEG', 'MR'}                                |
| TCGA-06-0162 |                   1 |                 18 | {'SEG', 'MR'}                                |
| TCGA-02-0106 |                   1 |                 18 | {'SEG', 'MR'}                                |
| TCGA-06-0145 |                   1 |                 18 | {'SEG', 'MR'}                                |
| TCGA-06-0176 |                   1 |                 17 | {'SEG', 'MR'}                                |
| TCGA-G2-AA3D |                   5 |                 17 | {'CR', 'CT', 'DX'}                           |
| TCGA-G2-A2EO |                   7 |                 17 | {'CR', 'CT', 'DX'}                           |
| TCGA-AO-A0JI |                   2 |                 17 | {'SR', 'MG', 'MR'}                           |
| TCGA-02-0116 |                   1 |                 17 | {'SEG', 'MR'}                                |
| TCGA-02-0009 |                   1 |                 16 | {'SEG', 'MR'}                                |
| TCGA-02-0006 |                   1 |                 16 | {'SEG', 'MR'}                                |
| TCGA-02-0046 |                   1 |                 16 | {'SEG', 'MR'}                                |
| TCGA-G7-A8LD |                   3 |                 16 | {'PT', 'CT', 'MR'}                           |
| TCGA-02-0102 |                   1 |                 16 | {'SEG', 'MR'}                                |
| TCGA-02-0085 |                   1 |                 16 | {'SEG', 'MR'}                                |
| TCGA-CR-6478 |                   2 |                 14 | {'PT', 'CT', 'MR'}                           |
| TCGA-CV-5973 |                   2 |                 13 | {'RTPLAN', 'CT', 'RTSTRUCT', 'RTDOSE'}       |
| TCGA-CV-5977 |                   2 |                 13 | {'RTPLAN', 'CT', 'RTDOSE', 'RTSTRUCT'}       |
| TCGA-CV-7235 |                   2 |                 10 | {'RTPLAN', 'CT', 'RTDOSE', 'RTSTRUCT'}       |
| TCGA-CV-5976 |                   2 |                 10 | {'RTDOSE', 'CT', 'RTSTRUCT', 'RTPLAN'}       |
| TCGA-CV-6433 |                   2 |                  9 | {'RTPLAN', 'CT', 'RTDOSE', 'RTSTRUCT'}       |
| TCGA-08-0509 |                   1 |                  8 | {'SEG', 'MR'}                                |
| TCGA-CV-5966 |                   2 |                  8 | {'RTPLAN', 'CT', 'RTDOSE', 'RTSTRUCT'}       |
| TCGA-CV-5978 |                   2 |                  8 | {'RTPLAN', 'CT', 'RTDOSE', 'RTSTRUCT'}       |
| TCGA-CV-5970 |                   2 |                  7 | {'RTPLAN', 'CT', 'RTSTRUCT', 'RTDOSE'}       |
| TCGA-CV-7236 |                   2 |                  7 | {'RTDOSE', 'CT', 'RTSTRUCT'}                 |
| TCGA-CV-7245 |                   2 |                  7 | {'RTPLAN', 'CT', 'RTSTRUCT', 'RTDOSE'}       |